<template>
<b-row align-v="center" class="mb-1">
  <b-col :cols="labelcols" v-if="labelcols>0" >
            <label>
                {{label}}
                <b-icon v-if="tooltip!=undefined" icon="info-square"
                :id="'info_icon_'+id" variant="info"></b-icon>
            </label>
  </b-col>
  <b-col :cols="computedCols" :md="computedMdCols">
    <b-form-textarea ref="textInput" size="sm" v-if="textArea"
      v-model="inputValue" @focus="onFocus($event)" rows=15
      class="form-control"
      type="text"
      :placeholder="placeholderContent">
    </b-form-textarea>
    <b-form-input ref="textInput" size="sm" v-else
      v-model="inputValue" @focus="onFocus($event)"
      class="form-control"
      type="text"
      :placeholder="placeholderContent">
    </b-form-input>
            <b-popover v-if="tooltip!=undefined"
              :target="'info_icon_'+id" triggers="hover" placement="top"
            :delay="{ show: 50, hide: 50 } ">
                {{tooltip}}
            </b-popover>
        </b-col>
    <b-col align-self="middle" v-if="colorPicker" cols="1" class="p-0">
    <b-button ref="buttonInput"
      style="height: 32px;width: 32px;border-radius: 0px;border: solid 1px black;"></b-button>
  </b-col>
  <slot></slot>
</b-row>
</template>

<script lang="ts">
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
import Component from 'vue-class-component';
import { v4 as uuidv4 } from 'uuid';
import Picker from 'vanilla-picker';
import BaseComponent from '../BaseComponent';

@Component({
  props: {
    label: String,
    tooltip: String,
    placeholder: {},
    colorPicker: { default: false },
    textArea: { default: false },
    cols: { default: 8 },
    md: { default: 8 },
    labelcols: { default: 4 },
    value: {},
  },
})
export default class FormTextInput extends BaseComponent {
  label!:string;

  value:any;

  cols!:number;

  md!:number;

  labelcols!:number;

  placeholder!:any;

  colorPicker!:boolean;

  id = uuidv4();

  picker!: Picker;

  mounted() {
    if (this.colorPicker) {
      const htmlinput:any = this.$refs.textInput;
      const buttoninput:any = this.$refs.buttonInput;
      let color = 'black';
      if (this.value) {
        color = this.value;
      } else if (this.placeholder) {
        color = this.placeholder;
      }
      buttoninput.style.backgroundColor = color;
      this.picker = new Picker({
        parent: buttoninput,
        popup: 'left',
        color,
      });
      // eslint-disable-next-line @typescript-eslint/no-this-alias
      const self = this;
      this.picker.onDone = function (newColor) {
        buttoninput.style.backgroundColor = newColor.rgbaString;
        self.inputValue = newColor.rgbaString;
      };
    }
  }

  get placeholderContent() {
    if (this.placeholder !== undefined) return `${this.placeholder}`;
    return '';
  }

  onFocus(e:Event) :void{
    if (this.colorPicker) {
      console.log('openHandler');
      // eslint-disable-next-line @typescript-eslint/no-this-alias
      const self = this;
      setTimeout(() => {
        self.picker.openHandler(e);
      }, 100);
    }
  }

  get computedCols() {
    if (this.colorPicker) {
      return this.cols - 1;
    }
    return this.cols;
  }

  get computedMdCols() {
    if (this.colorPicker) {
      return this.md - 1;
    }
    return this.md;
  }

  // model:any=null;
  get inputValue() {
    return this.value;
  }

  set inputValue(val) {
    this.$emit('input', val);
    this.$emit('inputChange', val);
  }
}
</script>

<style scoped lang="less">

</style>
